# Get Hourly Report Presets

GET https://api.letsdeel.com/rest/v2/contracts/{contract_id}/timesheets/presets

Retrieve hourly report presets for a given contract and work statement.
 **Token scopes**: `timesheets:read`

Reference: https://developer.deel.com/api/endpoints/projects/get-contract-timesheets-presets

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /contracts/{contract_id}/timesheets/presets:
    get:
      operationId: get-contract-timesheets-presets
      summary: Get Hourly Report Presets
      description: |-
        Retrieve hourly report presets for a given contract and work statement.
         **Token scopes**: `timesheets:read`
      tags:
        - subpackage_projects
      parameters:
        - name: contract_id
          in: path
          description: ID of the Deel contract
          required: true
          schema:
            type: string
            format: uuid
        - name: work_statement_id
          in: query
          description: ID of the work statement (optional)
          required: false
          schema:
            type: string
            format: uuid
        - name: order_by
          in: query
          description: Field to order results by (title or created_at)
          required: false
          schema:
            type: string
            default: title
        - name: order_direction
          in: query
          description: Direction of ordering (ASC or DESC)
          required: false
          schema:
            type: string
            default: ASC
        - name: cursor
          in: query
          description: Pagination cursor for fetching next set of results
          required: false
          schema:
            type: string
        - name: limit
          in: query
          description: Number of results to return per page
          required: false
          schema:
            type: integer
            default: 100
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Projects_getContractTimesheetsPresets_Response_200
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/GetHourlyReportPresetsRequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile:
      type: object
      properties:
        id:
          type: string
          description: The unique identifier of the file
        name:
          type: string
          description: The name of the file
        type:
          type: string
          description: The type of the file
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetFile:
      type: object
      properties:
        id:
          type: string
          description: The unique identifier of the file
        name:
          type: string
          description: The name of the file
        type:
          type: string
          description: The type of the file
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetFile
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetType:
      type: string
      enum:
        - RATE
        - TRACKING
      description: The type of preset based on type of root preset
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetType
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPreset:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the root preset
        file:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetFile
            - type: 'null'
        type:
          $ref: >-
            #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPresetType
          description: The type of preset based on type of root preset
        title:
          type: string
          description: The title of the root preset template
        description:
          type: string
          description: Detailed description of the root preset template
      required:
        - id
        - title
        - description
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPreset
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the hourly report preset
        file:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile
            - type: 'null'
        rate:
          type: number
          format: double
          description: The hourly rate for this preset
        title:
          type: string
          description: Title of the hourly report preset.
        description:
          type: string
          description: Detailed description of the hourly report preset
        hourly_report_root_preset:
          $ref: >-
            #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItemsHourlyReportRootPreset
      required:
        - id
        - rate
        - title
        - description
        - hourly_report_root_preset
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItems
    ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaPage:
      type: object
      properties:
        cursor:
          type: string
          description: Pagination cursor for fetching the next set of results
        total_rows:
          type: integer
          description: Total number of rows available in the result set
      required:
        - cursor
        - total_rows
      title: >-
        ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaPage
    Projects_getContractTimesheetsPresets_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaDataItems
        page:
          $ref: >-
            #/components/schemas/ContractsContractIdTimesheetsPresetsGetResponsesContentApplicationJsonSchemaPage
      required:
        - data
        - page
      title: Projects_getContractTimesheetsPresets_Response_200
    GetHourlyReportPresetsRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
      required:
        - error
      title: GetHourlyReportPresetsRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/contracts/contract_id/timesheets/presets")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```